diff --git a/babeld/babel_errors.c b/babeld/babel_errors.c
new file mode 100644
index 000000000000..ed780ea1bb18
--- /dev/null
+++ b/babeld/babel_errors.c
@@ -0,0 +1,60 @@
+/*
+ * babel_errors - code for error messages that may occur in the
+ *              babel process
+ * Copyright (C) 2018 Cumulus Networks, Inc.
+ *               Donald Sharp
+ *
+ * FRR is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2, or (at your option) any
+ * later version.
+ *
+ * FRR is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; see the file COPYING; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+#include <zebra.h>
+
+#include "babel_errors.h"
+
+static struct ferr_ref ferr_babel_err[] = {
+	{
+		.code = BABEL_ERR_MEMORY,
+		.title = "BABEL Memory Errors",
+		.description = "Babel has failed to allocate memory, the system is about to run out of memory",
+		.suggestion = "Find the process that is causing memory shortages and remediate that process\nRestart FRR"
+	},
+	{
+		.code = BABEL_ERR_PACKET,
+		.title = "BABEL Packet Error",
+		.description = "Babel has detected a packet encode/decode problem",
+		.suggestion = "Collect relevant log files and file an Issue"
+	},
+	{
+		.code = BABEL_ERR_CONFIG,
+		.title = "BABEL Configuration Error",
+		.description = "Babel has detected a configuration error of some sort",
+		.suggestion = "Ensure that the configuration is correct"
+	},
+	{
+		.code = BABEL_ERR_ROUTE,
+		.title = "BABEL Route Error",
+		.description = "Babel has detected a routing error and has an inconsistent state",
+		.suggestion = "Gather data for filing an Issue and then restart FRR"
+	},
+	{
+		.code = END_FERR,
+	}
+};
+
+void babel_error_init(void)
+{
+	ferr_ref_init();
+
+	ferr_ref_add(ferr_babel_err);
+}
diff --git a/babeld/babel_errors.h b/babeld/babel_errors.h
new file mode 100644
index 000000000000..a52b19481b0a
--- /dev/null
+++ b/babeld/babel_errors.h
@@ -0,0 +1,35 @@
+/*
+ * babel_errors - header for error messages that may occur in the babel process
+ * Copyright (C) 2018 Cumulus Networks, Inc.
+ *               Donald Sharp
+ *
+ * FRR is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2, or (at your option) any
+ * later version.
+ *
+ * FRR is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; see the file COPYING; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+#ifndef __BABEL_ERRORS_H__
+#define __BABEL_ERRORS_H__
+
+#include "ferr.h"
+#include "babel_errors.h"
+
+enum babel_ferr_refs {
+	BABEL_ERR_MEMORY = BABEL_FERR_START,
+	BABEL_ERR_PACKET,
+	BABEL_ERR_CONFIG,
+	BABEL_ERR_ROUTE,
+};
+
+extern void babel_error_init(void);
+
+#endif
diff --git a/babeld/babel_interface.c b/babeld/babel_interface.c
index d4958ddf249e..0b94e300ca5a 100644
--- a/babeld/babel_interface.c
+++ b/babeld/babel_interface.c
@@ -27,6 +27,7 @@ THE SOFTWARE.
 #include "prefix.h"
 #include "vector.h"
 #include "distribute.h"
+#include "lib_errors.h"
 
 #include "babel_main.h"
 #include "util.h"
@@ -39,6 +40,7 @@ THE SOFTWARE.
 #include "route.h"
 #include "xroute.h"
 #include "babel_memory.h"
+#include "babel_errors.h"
 
 #define IS_ENABLE(ifp) (babel_enable_if_lookup(ifp->name) >= 0)
 
@@ -167,7 +169,7 @@ babel_interface_address_add (int cmd, struct zclient *client,
         if (babel_ifp->ipv4 == NULL) {
             babel_ifp->ipv4 = malloc(4);
             if (babel_ifp->ipv4 == NULL) {
-                zlog_err("not einough memory");
+                zlog_ferr(BABEL_ERR_MEMORY, "not enough memory");
             } else {
                 memcpy(babel_ifp->ipv4, &prefix->u.prefix4, 4);
             }
@@ -707,7 +709,7 @@ interface_recalculate(struct interface *ifp)
     tmp = babel_ifp->sendbuf;
     babel_ifp->sendbuf = realloc(babel_ifp->sendbuf, babel_ifp->bufsize);
     if(babel_ifp->sendbuf == NULL) {
-        zlog_err("Couldn't reallocate sendbuf.");
+        zlog_ferr(BABEL_ERR_MEMORY, "Couldn't reallocate sendbuf.");
         free(tmp);
         babel_ifp->bufsize = 0;
         return -1;
@@ -727,8 +729,9 @@ interface_recalculate(struct interface *ifp)
     rc = setsockopt(protocol_socket, IPPROTO_IPV6, IPV6_JOIN_GROUP,
                     (char*)&mreq, sizeof(mreq));
     if(rc < 0) {
-        zlog_err("setsockopt(IPV6_JOIN_GROUP) on interface '%s': %s",
-                 ifp->name, safe_strerror(errno));
+        zlog_ferr(LIB_ERR_SOCKET,
+		  "setsockopt(IPV6_JOIN_GROUP) on interface '%s': %s",
+                  ifp->name, safe_strerror(errno));
         /* This is probably due to a missing link-local address,
          so down this interface, and wait until the main loop
          tries to up it again. */
@@ -790,8 +793,9 @@ interface_reset(struct interface *ifp)
         rc = setsockopt(protocol_socket, IPPROTO_IPV6, IPV6_LEAVE_GROUP,
                         (char*)&mreq, sizeof(mreq));
         if(rc < 0)
-            zlog_err("setsockopt(IPV6_LEAVE_GROUP) on interface '%s': %s",
-                     ifp->name, safe_strerror(errno));
+            zlog_ferr(LIB_ERR_SOCKET,
+		      "setsockopt(IPV6_LEAVE_GROUP) on interface '%s': %s",
+                      ifp->name, safe_strerror(errno));
     }
 
     update_interface_metric(ifp);
@@ -1056,7 +1060,7 @@ DEFUN (show_babel_route,
         }
         route_stream_done(routes);
     } else {
-        zlog_err("Couldn't allocate route stream.");
+        zlog_ferr(BABEL_ERR_MEMORY, "Couldn't allocate route stream.");
     }
     xroutes = xroute_stream();
     if(xroutes) {
@@ -1068,7 +1072,7 @@ DEFUN (show_babel_route,
         }
         xroute_stream_done(xroutes);
     } else {
-        zlog_err("Couldn't allocate route stream.");
+        zlog_ferr(BABEL_ERR_MEMORY, "Couldn't allocate route stream.");
     }
     return CMD_SUCCESS;
 }
@@ -1103,7 +1107,7 @@ DEFUN (show_babel_route_prefix,
         }
         route_stream_done(routes);
     } else {
-        zlog_err("Couldn't allocate route stream.");
+        zlog_ferr(BABEL_ERR_MEMORY, "Couldn't allocate route stream.");
     }
     xroutes = xroute_stream();
     if(xroutes) {
@@ -1115,7 +1119,7 @@ DEFUN (show_babel_route_prefix,
         }
         xroute_stream_done(xroutes);
     } else {
-        zlog_err("Couldn't allocate route stream.");
+        zlog_ferr(BABEL_ERR_MEMORY, "Couldn't allocate route stream.");
     }
     return CMD_SUCCESS;
 }
@@ -1161,7 +1165,7 @@ DEFUN (show_babel_route_addr,
         }
         route_stream_done(routes);
     } else {
-        zlog_err("Couldn't allocate route stream.");
+        zlog_ferr(BABEL_ERR_MEMORY, "Couldn't allocate route stream.");
     }
     xroutes = xroute_stream();
     if(xroutes) {
@@ -1173,7 +1177,7 @@ DEFUN (show_babel_route_addr,
         }
         xroute_stream_done(xroutes);
     } else {
-        zlog_err("Couldn't allocate route stream.");
+        zlog_ferr(BABEL_ERR_MEMORY, "Couldn't allocate route stream.");
     }
     return CMD_SUCCESS;
 }
@@ -1220,7 +1224,7 @@ DEFUN (show_babel_route_addr6,
         }
         route_stream_done(routes);
     } else {
-        zlog_err("Couldn't allocate route stream.");
+        zlog_ferr(BABEL_ERR_MEMORY, "Couldn't allocate route stream.");
     }
     xroutes = xroute_stream();
     if(xroutes) {
@@ -1232,7 +1236,7 @@ DEFUN (show_babel_route_addr6,
         }
         xroute_stream_done(xroutes);
     } else {
-        zlog_err("Couldn't allocate route stream.");
+        zlog_ferr(BABEL_ERR_MEMORY, "Couldn't allocate route stream.");
     }
     return CMD_SUCCESS;
 }
diff --git a/babeld/babel_main.c b/babeld/babel_main.c
index 9ea123c8f9e6..fd97099dde62 100644
--- a/babeld/babel_main.c
+++ b/babeld/babel_main.c
@@ -33,6 +33,7 @@ THE SOFTWARE.
 #include "vty.h"
 #include "memory.h"
 #include "libfrr.h"
+#include "lib_errors.h"
 
 #include "babel_main.h"
 #include "babeld.h"
@@ -45,6 +46,7 @@ THE SOFTWARE.
 #include "message.h"
 #include "resend.h"
 #include "babel_zebra.h"
+#include "babel_errors.h"
 
 static void babel_fail(void);
 static void babel_init_random(void);
@@ -151,7 +153,7 @@ main(int argc, char **argv)
 
     frr_preinit (&babeld_di, argc, argv);
     frr_opt_add ("", longopts, "");
-  
+
     babel_init_random();
 
     /* set the Babel's default link-local multicast address and Babel's port */
@@ -181,6 +183,7 @@ main(int argc, char **argv)
     master = frr_init ();
 
     /* Library inits. */
+    babel_error_init();
     zprivs_init (&babeld_privs);
     cmd_init (1);
     vty_init (master);
@@ -228,7 +231,8 @@ babel_init_random(void)
 
     rc = read_random_bytes(&seed, sizeof(seed));
     if(rc < 0) {
-        zlog_err("read(random): %s", safe_strerror(errno));
+        zlog_ferr(LIB_ERR_SYSTEM_CALL, "read(random): %s",
+		  safe_strerror(errno));
         seed = 42;
     }
 
@@ -248,13 +252,14 @@ babel_replace_by_null(int fd)
 
     fd_null = open("/dev/null", O_RDONLY);
     if(fd_null < 0) {
-        zlog_err("open(null): %s", safe_strerror(errno));
+        zlog_ferr(LIB_ERR_SYSTEM_CALL, "open(null): %s", safe_strerror(errno));
         exit(1);
     }
 
     rc = dup2(fd_null, fd);
     if(rc < 0) {
-        zlog_err("dup2(null, 0): %s", safe_strerror(errno));
+        zlog_ferr(LIB_ERR_SYSTEM_CALL, "dup2(null, 0): %s",
+		  safe_strerror(errno));
         exit(1);
     }
 
@@ -273,10 +278,12 @@ babel_load_state_file(void)
 
     fd = open(state_file, O_RDONLY);
     if(fd < 0 && errno != ENOENT)
-        zlog_err("open(babel-state: %s)", safe_strerror(errno));
+        zlog_ferr(LIB_ERR_SYSTEM_CALL, "open(babel-state: %s)",
+		  safe_strerror(errno));
     rc = unlink(state_file);
     if(fd >= 0 && rc < 0) {
-        zlog_err("unlink(babel-state): %s", safe_strerror(errno));
+        zlog_ferr(LIB_ERR_SYSTEM_CALL, "unlink(babel-state): %s",
+		  safe_strerror(errno));
         /* If we couldn't unlink it, it's probably stale. */
         goto fini;
     }
@@ -287,7 +294,8 @@ babel_load_state_file(void)
         long t;
         rc = read(fd, buf, 99);
         if(rc < 0) {
-            zlog_err("read(babel-state): %s", safe_strerror(errno));
+            zlog_ferr(LIB_ERR_SYSTEM_CALL, "read(babel-state): %s",
+		      safe_strerror(errno));
         } else {
             buf[rc] = '\0';
             rc = sscanf(buf, "%99s %d %ld\n", buf2, &s, &t);
@@ -295,7 +303,7 @@ babel_load_state_file(void)
                 unsigned char sid[8];
                 rc = parse_eui64(buf2, sid);
                 if(rc < 0) {
-                    zlog_err("Couldn't parse babel-state.");
+                    zlog_ferr(BABEL_ERR_CONFIG, "Couldn't parse babel-state.");
                 } else {
                     struct timeval realnow;
                     debugf(BABEL_DEBUG_COMMON,
@@ -305,12 +313,13 @@ babel_load_state_file(void)
                     if(memcmp(sid, myid, 8) == 0)
                         myseqno = seqno_plus(s, 1);
                     else
-                        zlog_err("ID mismatch in babel-state. id=%s; old=%s",
+                        zlog_ferr(BABEL_ERR_CONFIG,
+				 "ID mismatch in babel-state. id=%s; old=%s",
                                  format_eui64(myid),
                                  format_eui64(sid));
                 }
             } else {
-                zlog_err("Couldn't parse babel-state.");
+                zlog_ferr(BABEL_ERR_CONFIG, "Couldn't parse babel-state.");
             }
         }
         goto fini;
@@ -350,7 +359,8 @@ babel_save_state_file(void)
     debugf(BABEL_DEBUG_COMMON, "Save state file.");
     fd = open(state_file, O_WRONLY | O_TRUNC | O_CREAT, 0644);
     if(fd < 0) {
-        zlog_err("creat(babel-state): %s", safe_strerror(errno));
+        zlog_ferr(LIB_ERR_SYSTEM_CALL, "creat(babel-state): %s",
+		  safe_strerror(errno));
         unlink(state_file);
     } else {
         struct timeval realnow;
@@ -360,12 +370,13 @@ babel_save_state_file(void)
                       format_eui64(myid), (int)myseqno,
                       (long)realnow.tv_sec);
         if(rc < 0 || rc >= 100) {
-            zlog_err("write(babel-state): overflow.");
+            zlog_ferr(BABEL_ERR_CONFIG, "write(babel-state): overflow.");
             unlink(state_file);
         } else {
             rc = write(fd, buf, rc);
             if(rc < 0) {
-                zlog_err("write(babel-state): %s", safe_strerror(errno));
+                zlog_ferr(BABEL_ERR_CONFIG, "write(babel-state): %s",
+			  safe_strerror(errno));
                 unlink(state_file);
             }
             fsync(fd);
diff --git a/babeld/babeld.c b/babeld/babeld.c
index 20dd098f3302..dd076714286f 100644
--- a/babeld/babeld.c
+++ b/babeld/babeld.c
@@ -29,6 +29,7 @@ THE SOFTWARE.
 #include "prefix.h"
 #include "filter.h"
 #include "plist.h"
+#include "lib_errors.h"
 
 #include "babel_main.h"
 #include "babeld.h"
@@ -43,6 +44,7 @@ THE SOFTWARE.
 #include "babel_filter.h"
 #include "babel_zebra.h"
 #include "babel_memory.h"
+#include "babel_errors.h"
 
 static int babel_init_routing_process(struct thread *thread);
 static void babel_get_myid(void);
@@ -143,7 +145,8 @@ babel_create_routing_process (void)
     /* Make socket for Babel protocol. */
     protocol_socket = babel_socket(protocol_port);
     if (protocol_socket < 0) {
-        zlog_err("Couldn't create link local socket: %s", safe_strerror(errno));
+        zlog_ferr(LIB_ERR_SOCKET, "Couldn't create link local socket: %s",
+		  safe_strerror(errno));
         goto fail;
     }
 
@@ -176,7 +179,7 @@ babel_read_protocol (struct thread *thread)
                     (struct sockaddr*)&sin6, sizeof(sin6));
     if(rc < 0) {
         if(errno != EAGAIN && errno != EINTR) {
-            zlog_err("recv: %s", safe_strerror(errno));
+            zlog_ferr(LIB_ERR_SOCKET, "recv: %s", safe_strerror(errno));
         }
     } else {
         FOR_ALL_INTERFACES(vrf, ifp) {
@@ -252,11 +255,13 @@ babel_get_myid(void)
         return;
     }
 
-    zlog_err("Warning: couldn't find router id -- using random value.");
+    zlog_ferr(BABEL_ERR_CONFIG,
+	      "Warning: couldn't find router id -- using random value.");
 
     rc = read_random_bytes(myid, 8);
     if(rc < 0) {
-        zlog_err("read(random): %s (cannot assign an ID)",safe_strerror(errno));
+        zlog_ferr(BABEL_ERR_CONFIG, "read(random): %s (cannot assign an ID)",
+		  safe_strerror(errno));
         exit(1);
     }
     /* Clear group and global bits */
@@ -514,7 +519,8 @@ resize_receive_buffer(int size)
     if(receive_buffer == NULL) {
         receive_buffer = malloc(size);
         if(receive_buffer == NULL) {
-            zlog_err("malloc(receive_buffer): %s", safe_strerror(errno));
+            zlog_ferr(BABEL_ERR_MEMORY, "malloc(receive_buffer): %s",
+		      safe_strerror(errno));
             return -1;
         }
         receive_buffer_size = size;
@@ -522,7 +528,8 @@ resize_receive_buffer(int size)
         unsigned char *new;
         new = realloc(receive_buffer, size);
         if(new == NULL) {
-            zlog_err("realloc(receive_buffer): %s", safe_strerror(errno));
+            zlog_ferr(BABEL_ERR_MEMORY, "realloc(receive_buffer): %s",
+		      safe_strerror(errno));
             return -1;
         }
         receive_buffer = new;
diff --git a/babeld/kernel.c b/babeld/kernel.c
index 7e78b6dec70d..ba2b58131c96 100644
--- a/babeld/kernel.c
+++ b/babeld/kernel.c
@@ -73,9 +73,9 @@ kernel_interface_wireless(struct interface *interface)
 }
 
 int
-kernel_route(int operation, const unsigned char *pref, unsigned short plen,
-             const unsigned char *gate, int ifindex, unsigned int metric,
-             const unsigned char *newgate, int newifindex,
+kernel_route(enum babel_kernel_routes operation, const unsigned char *pref,
+	     unsigned short plen, const unsigned char *gate, int ifindex,
+	     unsigned int metric, const unsigned char *newgate, int newifindex,
              unsigned int newmetric)
 {
     int rc;
@@ -116,12 +116,9 @@ kernel_route(int operation, const unsigned char *pref, unsigned short plen,
                              newmetric);
             return rc;
             break;
-        default:
-            zlog_err("this should never happen (false value - kernel_route)");
-            assert(0);
-            exit(1);
-            break;
     }
+
+    return 0;
 }
 
 static int
diff --git a/babeld/kernel.h b/babeld/kernel.h
index eb1e793279c5..5b1437ef3e44 100644
--- a/babeld/kernel.h
+++ b/babeld/kernel.h
@@ -29,17 +29,19 @@ THE SOFTWARE.
 
 #define KERNEL_INFINITY 0xFFFF
 
-#define ROUTE_FLUSH 0
-#define ROUTE_ADD 1
-#define ROUTE_MODIFY 2
+enum babel_kernel_routes {
+    ROUTE_FLUSH,
+    ROUTE_ADD,
+    ROUTE_MODIFY,
+};
 
 int kernel_interface_operational(struct interface *interface);
 int kernel_interface_mtu(struct interface *interface);
 int kernel_interface_wireless(struct interface *interface);
-int kernel_route(int operation, const unsigned char *dest, unsigned short plen,
-                 const unsigned char *gate, int ifindex, unsigned int metric,
-                 const unsigned char *newgate, int newifindex,
-                 unsigned int newmetric);
+int kernel_route(enum babel_kernel_routes operation, const unsigned char *dest,
+		 unsigned short plen, const unsigned char *gate, int ifindex,
+		 unsigned int metric, const unsigned char *newgate,
+		 int newifindex, unsigned int newmetric);
 int if_eui64(int ifindex, unsigned char *eui);
 int gettime(struct timeval *tv);
 int read_random_bytes(void *buf, size_t len);
diff --git a/babeld/message.c b/babeld/message.c
index 1ff4867908cf..d9300fe402c0 100644
--- a/babeld/message.c
+++ b/babeld/message.c
@@ -35,6 +35,7 @@ THE SOFTWARE.
 #include "message.h"
 #include "kernel.h"
 #include "babel_main.h"
+#include "babel_errors.h"
 
 static unsigned char packet_header[4] = {42, 2};
 
@@ -140,12 +141,12 @@ parse_update_subtlv(const unsigned char *a, int alen,
         }
 
         if(i + 1 > alen) {
-            zlog_err("Received truncated attributes.");
+            zlog_ferr(BABEL_ERR_PACKET, "Received truncated attributes.");
             return;
         }
         len = a[i + 1];
         if(i + len > alen) {
-            zlog_err("Received truncated attributes.");
+            zlog_ferr(BABEL_ERR_PACKET, "Received truncated attributes.");
             return;
         }
 
@@ -153,13 +154,14 @@ parse_update_subtlv(const unsigned char *a, int alen,
             /* Nothing. */
         } else if(type == SUBTLV_DIVERSITY) {
             if(len > DIVERSITY_HOPS) {
-                zlog_err("Received overlong channel information (%d > %d).n",
-                         len, DIVERSITY_HOPS);
+                zlog_ferr(BABEL_ERR_PACKET,
+			  "Received overlong channel information (%d > %d).n",
+                          len, DIVERSITY_HOPS);
                 len = DIVERSITY_HOPS;
             }
             if(memchr(a + i + 2, 0, len) != NULL) {
                 /* 0 is reserved. */
-                zlog_err("Channel information contains 0!");
+                zlog_ferr(BABEL_ERR_PACKET, "Channel information contains 0!");
                 return;
             }
             memset(channels, 0, DIVERSITY_HOPS);
@@ -187,12 +189,14 @@ parse_hello_subtlv(const unsigned char *a, int alen,
         }
 
         if(i + 1 > alen) {
-            zlog_err("Received truncated sub-TLV on Hello message.");
+            zlog_ferr(BABEL_ERR_PACKET,
+		      "Received truncated sub-TLV on Hello message.");
             return -1;
         }
         len = a[i + 1];
         if(i + len > alen) {
-            zlog_err("Received truncated sub-TLV on Hello message.");
+            zlog_ferr(BABEL_ERR_PACKET,
+		      "Received truncated sub-TLV on Hello message.");
             return -1;
         }
 
@@ -203,7 +207,8 @@ parse_hello_subtlv(const unsigned char *a, int alen,
                 DO_NTOHL(*hello_send_us, a + i + 2);
                 ret = 1;
             } else {
-                zlog_err("Received incorrect RTT sub-TLV on Hello message.");
+                zlog_ferr(BABEL_ERR_PACKET,
+			  "Received incorrect RTT sub-TLV on Hello message.");
             }
         } else {
             debugf(BABEL_DEBUG_COMMON,
@@ -230,12 +235,14 @@ parse_ihu_subtlv(const unsigned char *a, int alen,
         }
 
         if(i + 1 > alen) {
-            zlog_err("Received truncated sub-TLV on IHU message.");
+            zlog_ferr(BABEL_ERR_PACKET,
+		      "Received truncated sub-TLV on IHU message.");
             return -1;
         }
         len = a[i + 1];
         if(i + len > alen) {
-            zlog_err("Received truncated sub-TLV on IHU message.");
+            zlog_ferr(BABEL_ERR_PACKET,
+		      "Received truncated sub-TLV on IHU message.");
             return -1;
         }
 
@@ -248,7 +255,8 @@ parse_ihu_subtlv(const unsigned char *a, int alen,
                 ret = 1;
             }
             else {
-                zlog_err("Received incorrect RTT sub-TLV on IHU message.");
+                zlog_ferr(BABEL_ERR_PACKET,
+			  "Received incorrect RTT sub-TLV on IHU message.");
             }
         } else {
             debugf(BABEL_DEBUG_COMMON,
@@ -337,27 +345,29 @@ parse_packet(const unsigned char *from, struct interface *ifp,
     }
 
     if(!linklocal(from)) {
-        zlog_err("Received packet from non-local address %s.",
-                 format_address(from));
+        zlog_ferr(BABEL_ERR_PACKET,
+		  "Received packet from non-local address %s.",
+                  format_address(from));
         return;
     }
 
     if (babel_packet_examin (packet, packetlen)) {
-        zlog_err("Received malformed packet on %s from %s.",
-                 ifp->name, format_address(from));
+        zlog_ferr(BABEL_ERR_PACKET,
+		  "Received malformed packet on %s from %s.",
+                  ifp->name, format_address(from));
         return;
     }
 
     neigh = find_neighbour(from, ifp);
     if(neigh == NULL) {
-        zlog_err("Couldn't allocate neighbour.");
+        zlog_ferr(BABEL_ERR_PACKET, "Couldn't allocate neighbour.");
         return;
     }
 
     DO_NTOHS(bodylen, packet + 2);
 
     if(bodylen + 4 > packetlen) {
-        zlog_err("Received truncated packet (%d + 4 > %d).",
+        zlog_ferr(BABEL_ERR_PACKET, "Received truncated packet (%d + 4 > %d).",
                  bodylen, packetlen);
         bodylen = packetlen - 4;
     }
@@ -506,7 +516,8 @@ parse_packet(const unsigned char *from, struct interface *ifp,
                 have_router_id = 1;
             }
             if(!have_router_id && message[2] != 0) {
-                zlog_err("Received prefix with no router id.");
+                zlog_ferr(BABEL_ERR_PACKET,
+			  "Received prefix with no router id.");
                 goto fail;
             }
             debugf(BABEL_DEBUG_COMMON,"Received update%s%s for %s from %s on %s.",
@@ -517,7 +528,8 @@ parse_packet(const unsigned char *from, struct interface *ifp,
 
             if(message[2] == 0) {
                 if(metric < 0xFFFF) {
-                    zlog_err("Received wildcard update with finite metric.");
+                    zlog_ferr(BABEL_ERR_PACKET,
+			      "Received wildcard update with finite metric.");
                     goto done;
                 }
                 retract_neighbour_routes(neigh);
@@ -609,8 +621,9 @@ parse_packet(const unsigned char *from, struct interface *ifp,
         continue;
 
     fail:
-        zlog_err("Couldn't parse packet (%d, %d) from %s on %s.",
-                 message[0], message[1], format_address(from), ifp->name);
+        zlog_ferr(BABEL_ERR_PACKET,
+		  "Couldn't parse packet (%d, %d) from %s on %s.",
+                  message[0], message[1], format_address(from), ifp->name);
         goto done;
     }
 
@@ -697,7 +710,7 @@ fill_rtt_message(struct interface *ifp)
             DO_HTONL(babel_ifp->sendbuf + babel_ifp->buffered_hello + 10, time);
             return 1;
         } else {
-            zlog_err("No space left for timestamp sub-TLV "
+            zlog_ferr(BABEL_ERR_PACKET, "No space left for timestamp sub-TLV "
                      "(this shouldn't happen)");
             return -1;
         }
@@ -732,10 +745,11 @@ flushbuf(struct interface *ifp)
                             babel_ifp->sendbuf, babel_ifp->buffered,
                             (struct sockaddr*)&sin6, sizeof(sin6));
             if(rc < 0)
-                zlog_err("send: %s", safe_strerror(errno));
+                zlog_ferr(BABEL_ERR_PACKET, "send: %s", safe_strerror(errno));
         } else {
-            zlog_err("Warning: bucket full, dropping packet to %s.",
-                     ifp->name);
+            zlog_ferr(BABEL_ERR_PACKET,
+		      "Warning: bucket full, dropping packet to %s.",
+                      ifp->name);
         }
     }
     VALGRIND_MAKE_MEM_UNDEFINED(babel_ifp->sendbuf, babel_ifp->bufsize);
@@ -856,7 +870,8 @@ start_unicast_message(struct neighbour *neigh, int type, int len)
     if(!unicast_buffer)
         unicast_buffer = malloc(UNICAST_BUFSIZE);
     if(!unicast_buffer) {
-        zlog_err("malloc(unicast_buffer): %s", safe_strerror(errno));
+        zlog_ferr(BABEL_ERR_MEMORY, "malloc(unicast_buffer): %s",
+		  safe_strerror(errno));
         return -1;
     }
 
@@ -992,11 +1007,13 @@ flush_unicast(int dofree)
                         unicast_buffer, unicast_buffered,
                         (struct sockaddr*)&sin6, sizeof(sin6));
         if(rc < 0)
-            zlog_err("send(unicast): %s", safe_strerror(errno));
+            zlog_ferr(BABEL_ERR_PACKET, "send(unicast): %s",
+		      safe_strerror(errno));
     } else {
-        zlog_err("Warning: bucket full, dropping unicast packet to %s if %s.",
-                 format_address(unicast_neighbour->address),
-                 unicast_neighbour->ifp->name);
+        zlog_ferr(BABEL_ERR_PACKET,
+		  "Warning: bucket full, dropping unicast packet to %s if %s.",
+                  format_address(unicast_neighbour->address),
+                  unicast_neighbour->ifp->name);
     }
 
  done:
@@ -1301,7 +1318,8 @@ buffer_update(struct interface *ifp,
     again:
         babel_ifp->buffered_updates = malloc(n *sizeof(struct buffered_update));
         if(babel_ifp->buffered_updates == NULL) {
-            zlog_err("malloc(buffered_updates): %s", safe_strerror(errno));
+            zlog_ferr(BABEL_ERR_MEMORY, "malloc(buffered_updates): %s",
+		      safe_strerror(errno));
             if(n > 4) {
                 /* Try again with a tiny buffer. */
                 n = 4;
@@ -1364,7 +1382,7 @@ send_update(struct interface *ifp, int urgent,
             }
             route_stream_done(routes);
         } else {
-            zlog_err("Couldn't allocate route stream.");
+            zlog_ferr(BABEL_ERR_MEMORY, "Couldn't allocate route stream.");
         }
         set_timeout(&babel_ifp->update_timeout, babel_ifp->update_interval);
         babel_ifp->last_update_time = babel_now.tv_sec;
@@ -1442,7 +1460,7 @@ send_self_update(struct interface *ifp)
         }
         xroute_stream_done(xroutes);
     } else {
-        zlog_err("Couldn't allocate xroute stream.");
+        zlog_ferr(BABEL_ERR_MEMORY, "Couldn't allocate xroute stream.");
     }
 }
 
diff --git a/babeld/neighbour.c b/babeld/neighbour.c
index 48a32c4a9c39..2c1361542196 100644
--- a/babeld/neighbour.c
+++ b/babeld/neighbour.c
@@ -38,6 +38,7 @@ THE SOFTWARE.
 #include "route.h"
 #include "message.h"
 #include "resend.h"
+#include "babel_errors.h"
 
 struct neighbour *neighs = NULL;
 
@@ -89,7 +90,8 @@ find_neighbour(const unsigned char *address, struct interface *ifp)
 
     neigh = malloc(sizeof(struct neighbour));
     if(neigh == NULL) {
-        zlog_err("malloc(neighbour): %s", safe_strerror(errno));
+        zlog_ferr(BABEL_ERR_MEMORY, "malloc(neighbour): %s",
+		  safe_strerror(errno));
         return NULL;
     }
 
diff --git a/babeld/route.c b/babeld/route.c
index bc7590fb39b4..da2523469a0c 100644
--- a/babeld/route.c
+++ b/babeld/route.c
@@ -34,13 +34,14 @@ THE SOFTWARE.
 #include "xroute.h"
 #include "message.h"
 #include "resend.h"
+#include "babel_errors.h"
 
 static void consider_route(struct babel_route *route);
 
 struct babel_route **routes = NULL;
 static int route_slots = 0, max_route_slots = 0;
 int kernel_metric = 0;
-int diversity_kind = DIVERSITY_NONE;
+enum babel_diversity diversity_kind = DIVERSITY_NONE;
 int diversity_factor = BABEL_DEFAULT_DIVERSITY_FACTOR;
 int keep_unfeasible = 0;
 
@@ -398,15 +399,16 @@ install_route(struct babel_route *route)
         return;
 
     if(!route_feasible(route))
-        zlog_err("WARNING: installing unfeasible route "
-                 "(this shouldn't happen).");
+        zlog_ferr(BABEL_ERR_ROUTE, "WARNING: installing unfeasible route "
+                  "(this shouldn't happen).");
 
     i = find_route_slot(route->src->prefix, route->src->plen, NULL);
     assert(i >= 0 && i < route_slots);
 
     if(routes[i] != route && routes[i]->installed) {
-        zlog_err("WARNING: attempting to install duplicate route "
-                 "(this shouldn't happen).");
+        zlog_ferr(BABEL_ERR_ROUTE,
+		  "WARNING: attempting to install duplicate route "
+                  "(this shouldn't happen).");
         return;
     }
 
@@ -416,7 +418,8 @@ install_route(struct babel_route *route)
                       metric_to_kernel(route_metric(route)), NULL, 0, 0);
     if(rc < 0) {
         int save = errno;
-        zlog_err("kernel_route(ADD): %s", safe_strerror(errno));
+        zlog_ferr(BABEL_ERR_ROUTE, "kernel_route(ADD): %s",
+		  safe_strerror(errno));
         if(save != EEXIST)
             return;
     }
@@ -438,7 +441,8 @@ uninstall_route(struct babel_route *route)
                       route->neigh->ifp->ifindex,
                       metric_to_kernel(route_metric(route)), NULL, 0, 0);
     if(rc < 0)
-        zlog_err("kernel_route(FLUSH): %s", safe_strerror(errno));
+        zlog_ferr(BABEL_ERR_ROUTE, "kernel_route(FLUSH): %s",
+		  safe_strerror(errno));
 
     route->installed = 0;
 }
@@ -461,8 +465,8 @@ switch_routes(struct babel_route *old, struct babel_route *new)
         return;
 
     if(!route_feasible(new))
-        zlog_err("WARNING: switching to unfeasible route "
-                 "(this shouldn't happen).");
+        zlog_ferr(BABEL_ERR_ROUTE, "WARNING: switching to unfeasible route "
+                  "(this shouldn't happen).");
 
     rc = kernel_route(ROUTE_MODIFY, old->src->prefix, old->src->plen,
                       old->nexthop, old->neigh->ifp->ifindex,
@@ -470,7 +474,8 @@ switch_routes(struct babel_route *old, struct babel_route *new)
                       new->nexthop, new->neigh->ifp->ifindex,
                       metric_to_kernel(route_metric(new)));
     if(rc < 0) {
-        zlog_err("kernel_route(MODIFY): %s", safe_strerror(errno));
+        zlog_ferr(BABEL_ERR_ROUTE, "kernel_route(MODIFY): %s",
+		  safe_strerror(errno));
         return;
     }
 
@@ -498,7 +503,8 @@ change_route_metric(struct babel_route *route,
                           route->nexthop, route->neigh->ifp->ifindex,
                           new);
         if(rc < 0) {
-            zlog_err("kernel_route(MODIFY metric): %s", safe_strerror(errno));
+            zlog_ferr(BABEL_ERR_ROUTE, "kernel_route(MODIFY metric): %s",
+		      safe_strerror(errno));
             return;
         }
     }
@@ -581,10 +587,9 @@ route_interferes(struct babel_route *route, struct interface *ifp)
             }
         }
         return 0;
-    default:
-        zlog_err("Unknown kind of diversity.");
-        return 1;
     }
+
+    return 1;
 }
 
 int
@@ -793,7 +798,7 @@ update_route(const unsigned char *router_id,
         return NULL;
 
     if(martian_prefix(prefix, plen)) {
-        zlog_err("Rejecting martian route to %s through %s.",
+        zlog_ferr(BABEL_ERR_ROUTE, "Rejecting martian route to %s through %s.",
                  format_prefix(prefix, plen), format_address(nexthop));
         return NULL;
     }
@@ -901,7 +906,7 @@ update_route(const unsigned char *router_id,
         route->next = NULL;
         new_route = insert_route(route);
         if(new_route == NULL) {
-            zlog_err("Couldn't insert route.");
+            zlog_ferr(BABEL_ERR_ROUTE, "Couldn't insert route.");
             free(route);
             return NULL;
         }
diff --git a/babeld/route.h b/babeld/route.h
index c2026d176577..c994d22a9fb0 100644
--- a/babeld/route.h
+++ b/babeld/route.h
@@ -27,10 +27,12 @@ THE SOFTWARE.
 #include "babel_interface.h"
 #include "source.h"
 
-#define DIVERSITY_NONE 0
-#define DIVERSITY_INTERFACE_1 1
-#define DIVERSITY_CHANNEL_1 2
-#define DIVERSITY_CHANNEL 3
+enum babel_diversity {
+    DIVERSITY_NONE,
+    DIVERSITY_INTERFACE_1,
+    DIVERSITY_CHANNEL_1,
+    DIVERSITY_CHANNEL,
+};
 
 #define DIVERSITY_HOPS 8
 
@@ -55,7 +57,8 @@ struct route_stream;
 
 extern struct babel_route **routes;
 extern int kernel_metric;
-extern int diversity_kind, diversity_factor;
+extern enum babel_diversity diversity_kind;
+extern int diversity_factor;
 extern int keep_unfeasible;
 extern int smoothing_half_life;
 
diff --git a/babeld/source.c b/babeld/source.c
index 72396102b38c..6145743a4d68 100644
--- a/babeld/source.c
+++ b/babeld/source.c
@@ -31,6 +31,7 @@ THE SOFTWARE.
 #include "source.h"
 #include "babel_interface.h"
 #include "route.h"
+#include "babel_errors.h"
 
 struct source *srcs = NULL;
 
@@ -58,7 +59,7 @@ find_source(const unsigned char *id, const unsigned char *p, unsigned char plen,
 
     src = malloc(sizeof(struct source));
     if(src == NULL) {
-        zlog_err("malloc(source): %s", safe_strerror(errno));
+        zlog_ferr(BABEL_ERR_MEMORY, "malloc(source): %s", safe_strerror(errno));
         return NULL;
     }
 
diff --git a/babeld/subdir.am b/babeld/subdir.am
index c44cb275c238..6f91f7393079 100644
--- a/babeld/subdir.am
+++ b/babeld/subdir.am
@@ -9,6 +9,7 @@ dist_examples_DATA += babeld/babeld.conf.sample
 endif
 
 babeld_libbabel_a_SOURCES = \
+	babeld/babel_errors.c \
 	babeld/babel_filter.c \
 	babeld/babel_interface.c \
 	babeld/babel_memory.c \
@@ -26,6 +27,7 @@ babeld_libbabel_a_SOURCES = \
 	# end
 
 noinst_HEADERS += \
+	babeld/babel_errors.h \
 	babeld/babel_filter.h \
 	babeld/babel_interface.h \
 	babeld/babel_main.h \
diff --git a/bgpd/Makefile.am b/bgpd/Makefile.am
index 3880d2020da2..8c07e95105a6 100644
--- a/bgpd/Makefile.am
+++ b/bgpd/Makefile.am
@@ -85,7 +85,7 @@ libbgp_a_SOURCES = \
 	bgp_encap_tlv.c $(BGP_VNC_RFAPI_SRC) bgp_attr_evpn.c \
 	bgp_evpn.c bgp_evpn_vty.c bgp_vpn.c bgp_label.c bgp_rd.c \
 	bgp_keepalives.c bgp_io.c bgp_flowspec.c bgp_flowspec_util.c \
-	bgp_flowspec_vty.c bgp_labelpool.c bgp_pbr.c
+	bgp_flowspec_vty.c bgp_labelpool.c bgp_pbr.c bgp_errors.c
 
 noinst_HEADERS = \
 	bgp_memory.h \
@@ -99,7 +99,7 @@ noinst_HEADERS = \
 	$(BGP_VNC_RFAPI_HD) bgp_attr_evpn.h bgp_evpn.h bgp_evpn_vty.h \
         bgp_vpn.h bgp_label.h bgp_rd.h bgp_evpn_private.h bgp_keepalives.h \
 	bgp_io.h bgp_flowspec.h bgp_flowspec_private.h bgp_flowspec_util.h \
-	bgp_labelpool.h bgp_pbr.h
+	bgp_labelpool.h bgp_pbr.h bgp_errors.h
 
 bgpd_SOURCES = bgp_main.c
 bgpd_LDADD = libbgp.a  $(BGP_VNC_RFP_LIB) ../lib/libfrr.la @LIBCAP@ @LIBM@
diff --git a/bgpd/bgp_errors.c b/bgpd/bgp_errors.c
index c69035cac96d..71b19238f616 100644
--- a/bgpd/bgp_errors.c
+++ b/bgpd/bgp_errors.c
@@ -21,7 +21,7 @@
 #include <zebra.h>
 #include <bgp_errors.h>
 
-static struct ferr_ref ferr_lib_err[] = {
+static struct ferr_ref ferr_bgp_err[] = {
 	{
 		.code = BGP_ERR_ATTR_FLAG,
 		.title = "BGP attribute flag is incorrect",
@@ -64,12 +64,6 @@ static struct ferr_ref ferr_lib_err[] = {
 		.description = "BGP update has invalid length for PMSI tunnel",
 		.suggestion = "Determine the soure of the update and determine why the PMSI tunnel\nattribute length has been set incorrectly"
 	},
-	{
-		.code = BGP_ERR_NH_SEND_LEN,
-		.title = "BGP nethop length is invalid sending to peer",
-		.description = "BGP update has invalid length for nexthop sending to peer",
-		.suggestion = "Determine why the nexthop length has been set incorrectly"
-	},
 	{
 		.code = BGP_ERR_PEER_GROUP,
 		.title = "BGP peergroup operated on in error",
@@ -227,7 +221,7 @@ static struct ferr_ref ferr_lib_err[] = {
 	},
 	{
 		.code = BGP_ERR_VNI,
-		title = "BGP VNI creation issue",
+		.title = "BGP VNI creation issue",
 		.description = "BGP could not create a new VNI",
 		.suggestion = "Most likely a bug. If the problem persists, report the problem for troubleshooting"
 	},
@@ -297,13 +291,12 @@ static struct ferr_ref ferr_lib_err[] = {
 		.description = "BGP configuration has AS and process name mismatch",
 		.suggestion = "Correct the configuration so that the BGP AS number and instance\nname are consistent"
 	},
-{
-	.code = END_FERR,
-}
-}
-;
+	{
+		.code = END_FERR,
+	}
+};
 
-void BGP_error_init(void)
+void bgp_error_init(void)
 {
 	ferr_ref_init();
 
diff --git a/bgpd/bgp_main.c b/bgpd/bgp_main.c
index 7cc46e020def..f7cb2dae38b7 100644
--- a/bgpd/bgp_main.c
+++ b/bgpd/bgp_main.c
@@ -60,6 +60,7 @@
 #include "bgpd/bgp_packet.h"
 #include "bgpd/bgp_keepalives.h"
 #include "bgpd/bgp_network.h"
+#include "bgpd/bgp_errors.h"
 
 #ifdef ENABLE_BGP_VNC
 #include "bgpd/rfapi/rfapi_backend.h"
@@ -419,6 +420,7 @@ int main(int argc, char **argv)
 	if (no_fib_flag)
 		bgp_option_set(BGP_OPT_NO_FIB);
 
+	bgp_error_init();
 	/* Initializations. */
 	bgp_vrf_init();
 
diff --git a/isisd/isis_bpf.c b/isisd/isis_bpf.c
index 2cc2fefd9a9a..b5a09aff229e 100644
--- a/isisd/isis_bpf.c
+++ b/isisd/isis_bpf.c
@@ -32,6 +32,7 @@
 #include "network.h"
 #include "stream.h"
 #include "if.h"
+#include "lib_errors.h"
 
 #include "isisd/dict.h"
 #include "isisd/isis_constants.h"
@@ -187,8 +188,8 @@ int isis_sock_init(struct isis_circuit *circuit)
 	int retval = ISIS_OK;
 
 	if (isisd_privs.change(ZPRIVS_RAISE))
-		zlog_err("%s: could not raise privs, %s", __func__,
-			 safe_strerror(errno));
+		zlog_ferr(LIB_ERR_PRIVILEGES, "%s: could not raise privs, %s",
+			  __func__, safe_strerror(errno));
 
 	retval = open_bpf_dev(circuit);
 
@@ -208,8 +209,8 @@ int isis_sock_init(struct isis_circuit *circuit)
 
 end:
 	if (isisd_privs.change(ZPRIVS_LOWER))
-		zlog_err("%s: could not lower privs, %s", __func__,
-			 safe_strerror(errno));
+		zlog_ferr(LIB_ERR_PRIVILEGES, "%s: could not lower privs, %s",
+			  __func__, safe_strerror(errno));
 
 	return retval;
 }
diff --git a/isisd/isis_circuit.c b/isisd/isis_circuit.c
index 7a89d56bd053..4f29a92ab05d 100644
--- a/isisd/isis_circuit.c
+++ b/isisd/isis_circuit.c
@@ -57,6 +57,7 @@
 #include "isisd/isis_events.h"
 #include "isisd/isis_te.h"
 #include "isisd/isis_mt.h"
+#include "isisd/isis_errors.h"
 
 DEFINE_QOBJ_TYPE(isis_circuit)
 
@@ -566,7 +567,8 @@ int isis_circuit_up(struct isis_circuit *circuit)
 		return ISIS_OK;
 
 	if (circuit->area->lsp_mtu > isis_circuit_pdu_size(circuit)) {
-		zlog_err(
+		zlog_ferr(
+			ISIS_ERR_CONFIG,
 			"Interface MTU %zu on %s is too low to support area lsp mtu %u!",
 			isis_circuit_pdu_size(circuit),
 			circuit->interface->name, circuit->area->lsp_mtu);
@@ -577,7 +579,9 @@ int isis_circuit_up(struct isis_circuit *circuit)
 	if (circuit->circ_type == CIRCUIT_T_BROADCAST) {
 		circuit->circuit_id = isis_circuit_id_gen(isis, circuit->interface);
 		if (!circuit->circuit_id) {
-			zlog_err("There are already 255 broadcast circuits active!");
+			zlog_ferr(
+				ISIS_ERR_CONFIG,
+				"There are already 255 broadcast circuits active!");
 			return ISIS_ERROR;
 		}
 
diff --git a/isisd/isis_csm.c b/isisd/isis_csm.c
index 10870d5c5021..691d2a43f9a4 100644
--- a/isisd/isis_csm.c
+++ b/isisd/isis_csm.c
@@ -47,6 +47,7 @@
 #include "isisd/isisd.h"
 #include "isisd/isis_csm.h"
 #include "isisd/isis_events.h"
+#include "isisd/isis_errors.h"
 
 extern struct isis *isis;
 
@@ -137,10 +138,12 @@ isis_csm_state_change(int event, struct isis_circuit *circuit, void *arg)
 		case IF_UP_FROM_Z:
 			isis_circuit_if_add(circuit, (struct interface *)arg);
 			if (isis_circuit_up(circuit) != ISIS_OK) {
-				zlog_err(
+				zlog_ferr(
+					ISIS_ERR_CONFIG,
 					"Could not bring up %s because of invalid config.",
 					circuit->interface->name);
-				zlog_err(
+				zlog_ferr(
+					ISIS_ERR_CONFIG,
 					"Clearing config for %s. Please re-examine it.",
 					circuit->interface->name);
 				if (circuit->ip_router) {
diff --git a/isisd/isis_dlpi.c b/isisd/isis_dlpi.c
index 718f3a8982a4..455a2ca3aaa5 100644
--- a/isisd/isis_dlpi.c
+++ b/isisd/isis_dlpi.c
@@ -36,6 +36,7 @@
 #include "network.h"
 #include "stream.h"
 #include "if.h"
+#include "lib_errors.h"
 
 #include "isisd/dict.h"
 #include "isisd/isis_constants.h"
@@ -468,8 +469,8 @@ int isis_sock_init(struct isis_circuit *circuit)
 	int retval = ISIS_OK;
 
 	if (isisd_privs.change(ZPRIVS_RAISE))
-		zlog_err("%s: could not raise privs, %s", __func__,
-			 safe_strerror(errno));
+		zlog_ferr(LIB_ERR_PRIVILEGE, "%s: could not raise privs, %s",
+			  __func__, safe_strerror(errno));
 
 	retval = open_dlpi_dev(circuit);
 
@@ -489,8 +490,8 @@ int isis_sock_init(struct isis_circuit *circuit)
 
 end:
 	if (isisd_privs.change(ZPRIVS_LOWER))
-		zlog_err("%s: could not lower privs, %s", __func__,
-			 safe_strerror(errno));
+		zlog_ferr(LIB_ERR_PRIVILEGE, "%s: could not lower privs, %s",
+			  __func__, safe_strerror(errno));
 
 	return retval;
 }
diff --git a/isisd/isis_errors.c b/isisd/isis_errors.c
new file mode 100644
index 000000000000..154ba2bb5b88
--- /dev/null
+++ b/isisd/isis_errors.c
@@ -0,0 +1,48 @@
+/*
+ * isis_errors - code for error messages that may occur in the
+ *              isis process
+ * Copyright (C) 2018 Cumulus Networks, Inc.
+ *               Donald Sharp
+ *
+ * FRR is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2, or (at your option) any
+ * later version.
+ *
+ * FRR is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; see the file COPYING; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+#include <zebra.h>
+
+#include "isis_errors.h"
+
+static struct ferr_ref ferr_isis_err[] = {
+	{
+		.code = ISIS_ERR_PACKET,
+		.title = "ISIS Packet Error",
+		.description = "Isis has detected an error with a packet from a peer",
+		.suggestion = "Gather log information and open an issue then restart FRR"
+	},
+	{
+		.code = ISIS_ERR_CONFIG,
+		.title = "ISIS Configuration Error",
+		.description = "Isis has detected an error within configuration for the router",
+		.suggestion = "Ensure configuration is correct"
+	},
+	{
+		.code = END_FERR,
+	}
+};
+
+void isis_error_init(void)
+{
+	ferr_ref_init();
+
+	ferr_ref_add(ferr_isis_err);
+}
diff --git a/isisd/isis_errors.h b/isisd/isis_errors.h
new file mode 100644
index 000000000000..d92a4e403813
--- /dev/null
+++ b/isisd/isis_errors.h
@@ -0,0 +1,33 @@
+/*
+ * isis_errors - header for error messages that may occur in the isis process
+ * Copyright (C) 2018 Cumulus Networks, Inc.
+ *               Donald Sharp
+ *
+ * FRR is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2, or (at your option) any
+ * later version.
+ *
+ * FRR is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; see the file COPYING; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+#ifndef __ISIS_ERRORS_H__
+#define __ISIS_ERRORS_H__
+
+#include "ferr.h"
+#include "isis_errors.h"
+
+enum isis_ferr_refs {
+	ISIS_ERR_PACKET = ISIS_FERR_START,
+	ISIS_ERR_CONFIG,
+};
+
+extern void isis_error_init(void);
+
+#endif
diff --git a/isisd/isis_events.c b/isisd/isis_events.c
index 349ec262c09f..ad0fbc97e397 100644
--- a/isisd/isis_events.c
+++ b/isisd/isis_events.c
@@ -48,6 +48,7 @@
 #include "isisd/isis_csm.h"
 #include "isisd/isis_events.h"
 #include "isisd/isis_spf.h"
+#include "isisd/isis_errors.h"
 
 /* debug isis-spf spf-events
  4w4d: ISIS-Spf (tlt): L2 SPF needed, new adjacency, from 0x609229F4
@@ -156,9 +157,9 @@ void isis_circuit_is_type_set(struct isis_circuit *circuit, int newtype)
 		return; /* No change */
 
 	if (!(newtype & circuit->area->is_type)) {
-		zlog_err(
-			"ISIS-Evt (%s) circuit type change - invalid level %s because"
-			" area is %s",
+		zlog_ferr(
+			ISIS_ERR_CONFIG,
+			"ISIS-Evt (%s) circuit type change - invalid level %s because area is %s",
 			circuit->area->area_tag, circuit_t2string(newtype),
 			circuit_t2string(circuit->area->is_type));
 		return;
diff --git a/isisd/isis_lsp.c b/isisd/isis_lsp.c
index 95fa38223e41..01da203b9153 100644
--- a/isisd/isis_lsp.c
+++ b/isisd/isis_lsp.c
@@ -37,6 +37,7 @@
 #include "checksum.h"
 #include "md5.h"
 #include "table.h"
+#include "lib_errors.h"
 
 #include "isisd/dict.h"
 #include "isisd/isis_constants.h"
@@ -455,7 +456,8 @@ void lsp_update(struct isis_lsp *lsp, struct isis_lsp_hdr *hdr,
 		struct isis_area *area, int level, bool confusion)
 {
 	if (lsp->own_lsp) {
-		zlog_err(
+		zlog_ferr(
+			LIB_ERR_DEVELOPMENT,
 			"ISIS-Upd (%s): BUG updating LSP %s still marked as own LSP",
 			area->area_tag, rawlspid_print(lsp->hdr.lsp_id));
 		lsp_clear_data(lsp);
@@ -1231,8 +1233,9 @@ static int lsp_regenerate(struct isis_area *area, int level)
 	lsp = lsp_search(lspid, lspdb);
 
 	if (!lsp) {
-		zlog_err("ISIS-Upd (%s): lsp_regenerate: no L%d LSP found!",
-			 area->area_tag, level);
+		zlog_ferr(LIB_ERR_DEVELOPMENT,
+			  "ISIS-Upd (%s): lsp_regenerate: no L%d LSP found!",
+			  area->area_tag, level);
 		return ISIS_ERROR;
 	}
 
@@ -1599,8 +1602,9 @@ static int lsp_regenerate_pseudo(struct isis_circuit *circuit, int level)
 	lsp = lsp_search(lsp_id, lspdb);
 
 	if (!lsp) {
-		zlog_err("lsp_regenerate_pseudo: no l%d LSP %s found!", level,
-			 rawlspid_print(lsp_id));
+		zlog_ferr(LIB_ERR_DEVELOPMENT,
+			  "lsp_regenerate_pseudo: no l%d LSP %s found!", level,
+			  rawlspid_print(lsp_id));
 		return ISIS_ERROR;
 	}
 
diff --git a/isisd/isis_main.c b/isisd/isis_main.c
index 40ceb99fb259..5b18ab0a2c0d 100644
--- a/isisd/isis_main.c
+++ b/isisd/isis_main.c
@@ -53,6 +53,7 @@
 #include "isisd/isis_routemap.h"
 #include "isisd/isis_zebra.h"
 #include "isisd/isis_te.h"
+#include "isisd/isis_errors.h"
 
 /* Default configuration file name */
 #define ISISD_DEFAULT_CONFIG "isisd.conf"
@@ -103,7 +104,7 @@ static __attribute__((__noreturn__)) void terminate(int i)
 
 void sighup(void)
 {
-	zlog_err("SIGHUP/reload is not implemented for isisd");
+	zlog_notice("SIGHUP/reload is not implemented for isisd");
 	return;
 }
 
@@ -189,6 +190,7 @@ int main(int argc, char **argv, char **envp)
 	/*
 	 *  initializations
 	 */
+	isis_error_init();
 	access_list_init();
 	vrf_init(NULL, NULL, NULL, NULL);
 	prefix_list_init();
diff --git a/isisd/isis_pdu.c b/isisd/isis_pdu.c
index 7a6c4dd2dc10..ae7d14e7a1df 100644
--- a/isisd/isis_pdu.c
+++ b/isisd/isis_pdu.c
@@ -34,6 +34,7 @@
 #include "if.h"
 #include "checksum.h"
 #include "md5.h"
+#include "lib_errors.h"
 
 #include "isisd/dict.h"
 #include "isisd/isis_constants.h"
@@ -54,6 +55,7 @@
 #include "isisd/isis_te.h"
 #include "isisd/isis_mt.h"
 #include "isisd/isis_tlvs.h"
+#include "isisd/isis_errors.h"
 
 static int ack_lsp(struct isis_lsp_hdr *hdr, struct isis_circuit *circuit,
 		   int level)
@@ -86,9 +88,10 @@ static int ack_lsp(struct isis_lsp_hdr *hdr, struct isis_circuit *circuit,
 
 	retval = circuit->tx(circuit, level);
 	if (retval != ISIS_OK)
-		zlog_err("ISIS-Upd (%s): Send L%d LSP PSNP on %s failed",
-			 circuit->area->area_tag, level,
-			 circuit->interface->name);
+		zlog_ferr(ISIS_ERR_PACKET,
+			  "ISIS-Upd (%s): Send L%d LSP PSNP on %s failed",
+			  circuit->area->area_tag, level,
+			  circuit->interface->name);
 
 	return retval;
 }
@@ -614,8 +617,9 @@ static int process_hello(uint8_t pdu_type, struct isis_circuit *circuit,
 	}
 
 	if (!p2p_hello && !(level & iih.circ_type)) {
-		zlog_err("Level %d LAN Hello with Circuit Type %d", level,
-			 iih.circ_type);
+		zlog_ferr(ISIS_ERR_PACKET,
+			  "Level %d LAN Hello with Circuit Type %d", level,
+			  iih.circ_type);
 		return ISIS_ERROR;
 	}
 
@@ -1343,7 +1347,7 @@ int isis_handle_pdu(struct isis_circuit *circuit, uint8_t *ssnpa)
 
 	/* Verify that at least the 8 bytes fixed header have been received */
 	if (stream_get_endp(circuit->rcv_stream) < ISIS_FIXED_HDR_LEN) {
-		zlog_err("PDU is too short to be IS-IS.");
+		zlog_ferr(ISIS_ERR_PACKET, "PDU is too short to be IS-IS.");
 		return ISIS_ERROR;
 	}
 
@@ -1358,12 +1362,14 @@ int isis_handle_pdu(struct isis_circuit *circuit, uint8_t *ssnpa)
 	uint8_t max_area_addrs = stream_getc(circuit->rcv_stream);
 
 	if (idrp == ISO9542_ESIS) {
-		zlog_err("No support for ES-IS packet IDRP=%" PRIx8, idrp);
+		zlog_ferr(LIB_ERR_DEVELOPMENT,
+			  "No support for ES-IS packet IDRP=%" PRIx8, idrp);
 		return ISIS_ERROR;
 	}
 
 	if (idrp != ISO10589_ISIS) {
-		zlog_err("Not an IS-IS packet IDRP=%" PRIx8, idrp);
+		zlog_ferr(ISIS_ERR_PACKET, "Not an IS-IS packet IDRP=%" PRIx8,
+			  idrp);
 		return ISIS_ERROR;
 	}
 
@@ -1373,7 +1379,8 @@ int isis_handle_pdu(struct isis_circuit *circuit, uint8_t *ssnpa)
 	}
 
 	if (id_len != 0 && id_len != ISIS_SYS_ID_LEN) {
-		zlog_err(
+		zlog_ferr(
+			ISIS_ERR_PACKET,
 			"IDFieldLengthMismatch: ID Length field in a received PDU  %" PRIu8
 			", while the parameter for this IS is %u",
 			id_len, ISIS_SYS_ID_LEN);
@@ -1387,14 +1394,16 @@ int isis_handle_pdu(struct isis_circuit *circuit, uint8_t *ssnpa)
 	}
 
 	if (length != expected_length) {
-		zlog_err("Exepected fixed header length = %" PRIu8
-			 " but got %" PRIu8,
-			 expected_length, length);
+		zlog_ferr(ISIS_ERR_PACKET,
+			  "Exepected fixed header length = %" PRIu8
+			  " but got %" PRIu8,
+			  expected_length, length);
 		return ISIS_ERROR;
 	}
 
 	if (stream_get_endp(circuit->rcv_stream) < length) {
-		zlog_err(
+		zlog_ferr(
+			ISIS_ERR_PACKET,
 			"PDU is too short to contain fixed header of given PDU type.");
 		return ISIS_ERROR;
 	}
@@ -1412,7 +1421,8 @@ int isis_handle_pdu(struct isis_circuit *circuit, uint8_t *ssnpa)
 
 	/* either 3 or 0 */
 	if (max_area_addrs != 0 && max_area_addrs != isis->max_area_addrs) {
-		zlog_err(
+		zlog_ferr(
+			ISIS_ERR_PACKET,
 			"maximumAreaAddressesMismatch: maximumAreaAdresses in a received PDU %" PRIu8
 			" while the parameter for this IS is %u",
 			max_area_addrs, isis->max_area_addrs);
@@ -1636,9 +1646,10 @@ int send_hello(struct isis_circuit *circuit, int level)
 
 	retval = circuit->tx(circuit, level);
 	if (retval != ISIS_OK)
-		zlog_err("ISIS-Adj (%s): Send L%d IIH on %s failed",
-			 circuit->area->area_tag, level,
-			 circuit->interface->name);
+		zlog_ferr(ISIS_ERR_PACKET,
+			  "ISIS-Adj (%s): Send L%d IIH on %s failed",
+			  circuit->area->area_tag, level,
+			  circuit->interface->name);
 
 	return retval;
 }
@@ -1833,9 +1844,10 @@ int send_csnp(struct isis_circuit *circuit, int level)
 
 		int retval = circuit->tx(circuit, level);
 		if (retval != ISIS_OK) {
-			zlog_err("ISIS-Snp (%s): Send L%d CSNP on %s failed",
-				 circuit->area->area_tag, level,
-				 circuit->interface->name);
+			zlog_ferr(ISIS_ERR_PACKET,
+				  "ISIS-Snp (%s): Send L%d CSNP on %s failed",
+				  circuit->area->area_tag, level,
+				  circuit->interface->name);
 			isis_free_tlvs(tlvs);
 			return retval;
 		}
@@ -1997,9 +2009,10 @@ static int send_psnp(int level, struct isis_circuit *circuit)
 
 		int retval = circuit->tx(circuit, level);
 		if (retval != ISIS_OK) {
-			zlog_err("ISIS-Snp (%s): Send L%d PSNP on %s failed",
-				 circuit->area->area_tag, level,
-				 circuit->interface->name);
+			zlog_ferr(ISIS_ERR_PACKET,
+				  "ISIS-Snp (%s): Send L%d PSNP on %s failed",
+				  circuit->area->area_tag, level,
+				  circuit->interface->name);
 			isis_free_tlvs(tlvs);
 			return retval;
 		}
@@ -2104,7 +2117,8 @@ int send_lsp(struct thread *thread)
 	 * than
 	 * the circuit's MTU. So handle and log this case here. */
 	if (stream_get_endp(lsp->pdu) > stream_get_size(circuit->snd_stream)) {
-		zlog_err(
+		zlog_ferr(
+			ISIS_ERR_PACKET,
 			"ISIS-Upd (%s): Can't send L%d LSP %s, seq 0x%08" PRIx32
 			", cksum 0x%04" PRIx16 ", lifetime %" PRIu16
 			"s on %s. LSP Size is %zu while interface stream size is %zu.",
@@ -2139,11 +2153,12 @@ int send_lsp(struct thread *thread)
 	clear_srm = 0;
 	retval = circuit->tx(circuit, lsp->level);
 	if (retval != ISIS_OK) {
-		zlog_err("ISIS-Upd (%s): Send L%d LSP on %s failed %s",
-			 circuit->area->area_tag, lsp->level,
-			 circuit->interface->name,
-			 (retval == ISIS_WARNING) ? "temporarily"
-						  : "permanently");
+		zlog_ferr(ISIS_ERR_PACKET,
+			  "ISIS-Upd (%s): Send L%d LSP on %s failed %s",
+			  circuit->area->area_tag, lsp->level,
+			  circuit->interface->name,
+			  (retval == ISIS_WARNING) ? "temporarily"
+						   : "permanently");
 	}
 
 out:
diff --git a/isisd/isis_pfpacket.c b/isisd/isis_pfpacket.c
index 6e56870ebd8c..cfa2ff937955 100644
--- a/isisd/isis_pfpacket.c
+++ b/isisd/isis_pfpacket.c
@@ -31,6 +31,7 @@
 #include "network.h"
 #include "stream.h"
 #include "if.h"
+#include "lib_errors.h"
 
 #include "isisd/dict.h"
 #include "isisd/isis_constants.h"
@@ -185,8 +186,8 @@ int isis_sock_init(struct isis_circuit *circuit)
 	int retval = ISIS_OK;
 
 	if (isisd_privs.change(ZPRIVS_RAISE))
-		zlog_err("%s: could not raise privs, %s", __func__,
-			 safe_strerror(errno));
+		zlog_ferr(LIB_ERR_PRIVILEGES, "%s: could not raise privs, %s",
+			  __func__, safe_strerror(errno));
 
 	retval = open_packet_socket(circuit);
 
@@ -210,8 +211,8 @@ int isis_sock_init(struct isis_circuit *circuit)
 
 end:
 	if (isisd_privs.change(ZPRIVS_LOWER))
-		zlog_err("%s: could not lower privs, %s", __func__,
-			 safe_strerror(errno));
+		zlog_ferr(LIB_ERR_PRIVILEGES, "%s: could not lower privs, %s",
+			  __func__, safe_strerror(errno));
 
 	return retval;
 }
diff --git a/isisd/isis_spf.c b/isisd/isis_spf.c
index 4350686b1a0b..8c26f93f9739 100644
--- a/isisd/isis_spf.c
+++ b/isisd/isis_spf.c
@@ -37,6 +37,7 @@
 #include "spf_backoff.h"
 #include "jhash.h"
 #include "skiplist.h"
+#include "lib_errors.h"
 
 #include "isis_constants.h"
 #include "isis_common.h"
@@ -418,7 +419,7 @@ static void isis_vertex_id_init(struct isis_vertex *vertex, void *id,
 		memcpy(&vertex->N.prefix, (struct prefix *)id,
 		       sizeof(struct prefix));
 	} else {
-		zlog_err("WTF!");
+		zlog_ferr(LIB_ERR_DEVELOPMENT, "Unknown Vertex Type");
 	}
 }
 
diff --git a/isisd/subdir.am b/isisd/subdir.am
index 7b56715fa917..7b8be46167cf 100644
--- a/isisd/subdir.am
+++ b/isisd/subdir.am
@@ -15,6 +15,7 @@ isisd_libisis_a_SOURCES = \
 	isisd/isis_csm.c \
 	isisd/isis_dr.c \
 	isisd/isis_dynhn.c \
+	isisd/isis_errors.c \
 	isisd/isis_events.c \
 	isisd/isis_flags.c \
 	isisd/isis_lsp.c \
@@ -44,6 +45,7 @@ noinst_HEADERS += \
 	isisd/isis_csm.h \
 	isisd/isis_dr.h \
 	isisd/isis_dynhn.h \
+	isisd/isis_errors.h \
 	isisd/isis_events.h \
 	isisd/isis_flags.h \
 	isisd/isis_lsp.h \
diff --git a/pimd/pim_errors.c b/pimd/pim_errors.c
new file mode 100644
index 000000000000..ffffa8dd9f3a
--- /dev/null
+++ b/pimd/pim_errors.c
@@ -0,0 +1,48 @@
+/*
+ * pim_errors - code for error messages that may occur in the
+ *              pim process
+ * Copyright (C) 2018 Cumulus Networks, Inc.
+ *               Donald Sharp
+ *
+ * FRR is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2, or (at your option) any
+ * later version.
+ *
+ * FRR is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; see the file COPYING; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+#include <zebra.h>
+
+#include "pim_errors.h"
+
+static struct ferr_ref ferr_pim_err[] = {
+	{
+		.code = PIM_ERR_MSDP_PACKET,
+		.title = "PIM MSDP Packet Error",
+		.description = "PIM has received a packet from a peer that does not correctly decode",
+		.suggestion = "Check MSDP peer and ensure it is correctly working"
+	},
+	{
+		.code = PIM_ERR_CONFIG,
+		.title = "PIM Configuration Error",
+		.description = "Pim has detected a configuration error",
+		.suggestion = "Ensure the configuration is correct and apply correct configuration"
+	},
+	{
+		.code = END_FERR,
+	}
+};
+
+void pim_error_init(void)
+{
+	ferr_ref_init();
+
+	ferr_ref_add(ferr_pim_err);
+}
diff --git a/pimd/pim_errors.h b/pimd/pim_errors.h
new file mode 100644
index 000000000000..bcb1628e6201
--- /dev/null
+++ b/pimd/pim_errors.h
@@ -0,0 +1,33 @@
+/*
+ * pim_errors - header for error messages that may occur in the pim process
+ * Copyright (C) 2018 Cumulus Networks, Inc.
+ *               Donald Sharp
+ *
+ * FRR is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the
+ * Free Software Foundation; either version 2, or (at your option) any
+ * later version.
+ *
+ * FRR is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with this program; see the file COPYING; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+#ifndef __PIM_ERRORS_H__
+#define __PIM_ERRORS_H__
+
+#include "ferr.h"
+#include "pim_errors.h"
+
+enum pim_ferr_refs {
+	PIM_ERR_MSDP_PACKET = PIM_FERR_START,
+	PIM_ERR_CONFIG,
+};
+
+extern void pim_error_init(void);
+
+#endif
diff --git a/pimd/pim_main.c b/pimd/pim_main.c
index c4cab25ae9b2..578794086d5e 100644
--- a/pimd/pim_main.c
+++ b/pimd/pim_main.c
@@ -47,6 +47,7 @@
 #include "pim_msdp.h"
 #include "pim_iface.h"
 #include "pim_bfd.h"
+#include "pim_errors.h"
 
 extern struct host host;
 
@@ -108,6 +109,7 @@ int main(int argc, char **argv, char **envp)
 	/*
 	 * Initializations
 	 */
+	pim_error_init();
 	pim_vrf_init();
 	access_list_init();
 	prefix_list_init();
diff --git a/pimd/pim_msdp_packet.c b/pimd/pim_msdp_packet.c
index 7aa9357b8535..5c950e8dc295 100644
--- a/pimd/pim_msdp_packet.c
+++ b/pimd/pim_msdp_packet.c
@@ -27,6 +27,7 @@
 
 #include "pimd.h"
 #include "pim_str.h"
+#include "pim_errors.h"
 
 #include "pim_msdp.h"
 #include "pim_msdp_packet.h"
@@ -483,8 +484,9 @@ static void pim_msdp_pkt_sa_rx_one(struct pim_msdp_peer *mp, struct in_addr rp)
 
 	if (prefix_len != 32) {
 		/* ignore SA update if the prefix length is not 32 */
-		zlog_err("rxed sa update with invalid prefix length %d",
-			 prefix_len);
+		zlog_ferr(PIM_ERR_MSDP_PACKET,
+			  "rxed sa update with invalid prefix length %d",
+			  prefix_len);
 		return;
 	}
 	if (PIM_DEBUG_MSDP_PACKETS) {
diff --git a/pimd/pim_msdp_socket.c b/pimd/pim_msdp_socket.c
index 5b1afb774b66..d5bd34557e81 100644
--- a/pimd/pim_msdp_socket.c
+++ b/pimd/pim_msdp_socket.c
@@ -30,6 +30,7 @@
 
 #include "pimd.h"
 #include "pim_sock.h"
+#include "pim_errors.h"
 
 #include "pim_msdp.h"
 #include "pim_msdp_socket.h"
@@ -93,8 +94,9 @@ static int pim_msdp_sock_accept(struct thread *thread)
 	if (!mp || !PIM_MSDP_PEER_IS_LISTENER(mp)) {
 		++pim->msdp.rejected_accepts;
 		if (PIM_DEBUG_MSDP_EVENTS) {
-			zlog_err("msdp peer connection refused from %s",
-				 sockunion2str(&su, buf, SU_ADDRSTRLEN));
+			zlog_ferr(PIM_ERR_MSDP_PACKET,
+				  "msdp peer connection refused from %s",
+				  sockunion2str(&su, buf, SU_ADDRSTRLEN));
 		}
 		close(msdp_sock);
 		return -1;
diff --git a/pimd/pim_pim.c b/pimd/pim_pim.c
index de09b070f467..0bde06225d7d 100644
--- a/pimd/pim_pim.c
+++ b/pimd/pim_pim.c
@@ -38,6 +38,7 @@
 #include "pim_assert.h"
 #include "pim_msg.h"
 #include "pim_register.h"
+#include "pim_errors.h"
 
 static int on_pim_hello_send(struct thread *t);
 static int pim_hello_send(struct interface *ifp, uint16_t holdtime);
@@ -115,8 +116,9 @@ void pim_sock_delete(struct interface *ifp, const char *delete_message)
 		  delete_message);
 
 	if (!ifp->info) {
-		zlog_err("%s: %s: but PIM not enabled on interface %s (!)",
-			 __PRETTY_FUNCTION__, delete_message, ifp->name);
+		zlog_ferr(PIM_ERR_CONFIG,
+			  "%s: %s: but PIM not enabled on interface %s (!)",
+			  __PRETTY_FUNCTION__, delete_message, ifp->name);
 		return;
 	}
 
diff --git a/pimd/pim_rp.c b/pimd/pim_rp.c
index 86278747a345..8e7815b184b3 100644
--- a/pimd/pim_rp.c
+++ b/pimd/pim_rp.c
@@ -108,7 +108,8 @@ void pim_rp_init(struct pim_instance *pim)
 	rp_info = XCALLOC(MTYPE_PIM_RP, sizeof(*rp_info));
 
 	if (!str2prefix("224.0.0.0/4", &rp_info->group)) {
-		zlog_err("Unable to convert 224.0.0.0/4 to prefix");
+		zlog_ferr(LIB_ERR_DEVELOPMENT,
+			  "Unable to convert 224.0.0.0/4 to prefix");
 		list_delete_and_null(&pim->rp_list);
 		route_table_finish(pim->rp_table);
 		XFREE(MTYPE_PIM_RP, rp_info);
diff --git a/pimd/pim_ssm.c b/pimd/pim_ssm.c
index d35f5cff7e3c..160b3afa32d2 100644
--- a/pimd/pim_ssm.c
+++ b/pimd/pim_ssm.c
@@ -24,6 +24,7 @@
 #include <lib/vty.h>
 #include <lib/vrf.h>
 #include <lib/plist.h>
+#include <lib/lib_errors.h>
 
 #include "pimd.h"
 #include "pim_ssm.h"
@@ -72,8 +73,9 @@ static int pim_is_grp_standard_ssm(struct prefix *group)
 
 	if (first) {
 		if (!str2prefix(PIM_SSM_STANDARD_RANGE, &group_ssm))
-			zlog_err("%s: Failure to Read Group Address: %s",
-				 __PRETTY_FUNCTION__, PIM_SSM_STANDARD_RANGE);
+			zlog_ferr(LIB_ERR_DEVELOPMENT,
+				  "%s: Failure to Read Group Address: %s",
+				  __PRETTY_FUNCTION__, PIM_SSM_STANDARD_RANGE);
 
 		first = 0;
 	}
diff --git a/pimd/pim_zlookup.c b/pimd/pim_zlookup.c
index 12958b0390a9..8b67fb7f59a6 100644
--- a/pimd/pim_zlookup.c
+++ b/pimd/pim_zlookup.c
@@ -315,14 +315,15 @@ static int zclient_lookup_nexthop_once(struct pim_instance *pim,
 
 	/* Check socket. */
 	if (zlookup->sock < 0) {
-		zlog_err("%s: zclient lookup socket is not connected",
-			 __PRETTY_FUNCTION__);
+		zlog_ferr(LIB_ERR_ZAPI_SOCKET,
+			  "%s: zclient lookup socket is not connected",
+			  __PRETTY_FUNCTION__);
 		zclient_lookup_failed(zlookup);
 		return -1;
 	}
 
 	if (pim->vrf->vrf_id == VRF_UNKNOWN) {
-		zlog_err(
+		zlog_notice(
 			"%s: VRF: %s does not fully exist yet, delaying lookup",
 			__PRETTY_FUNCTION__, pim->vrf->name);
 		return -1;
diff --git a/pimd/subdir.am b/pimd/subdir.am
index 0696d9b1e817..55d56ece9762 100644
--- a/pimd/subdir.am
+++ b/pimd/subdir.am
@@ -15,6 +15,7 @@ pimd_libpim_a_SOURCES = \
 	pimd/pim_bfd.c \
 	pimd/pim_br.c \
 	pimd/pim_cmd.c \
+	pimd/pim_errors.c \
 	pimd/pim_hello.c \
 	pimd/pim_iface.c \
 	pimd/pim_ifchannel.c \
@@ -64,6 +65,7 @@ noinst_HEADERS += \
 	pimd/pim_bfd.h \
 	pimd/pim_br.h \
 	pimd/pim_cmd.h \
+	pimd/pim_errors.h \
 	pimd/pim_hello.h \
 	pimd/pim_iface.h \
 	pimd/pim_ifchannel.h \
